// ========================================================
//
// 1421_D_ObstacleAvoid
// Finite State Machine
// 13-02-23
//
// ========================================================

#include <CBPFBO_StepperA.h>
#define DEBUG true 

#define HC_SR04_Tx 2
#define HC_SR04_Rx 3

#define STATE_WANDER 1
#define STATE_AVOID 2

#define wheelDia 49.9
#define axleLen 98.0

int desiredDist;
int vMax;
int state;
float dist;
float detectionDist;

void setup(){
  Serial.begin(9600); 
  // US-Sensor electronics   
  pinMode(HC_SR04_Tx,OUTPUT);
  pinMode(HC_SR04_Rx,INPUT);
  
  setRobotParams(wheelDia,axleLen);
  vMax = 15;

  // set the detection dist you want
  detectionDist = 200;
  // set initial state
  state = STATE_WANDER;
  
}

void loop() {

  switch(state){
    case STATE_WANDER:
      // Here's one thing to do
      desiredDist = 100;
      straightLine(desiredDist,vMax,true,true);
      // More stuff here ...

      // look for obstacle detected
      dist = getDistance();
      if((dist < detectionDist) && (dist > 0)) {
        state = STATE_AVOID;
      }
      break;

    case STATE_AVOID :
      // Do some motion here.
      
      break;
    // All done? So transit back to STATE_WANDER;
  }
                       
}

float getDistance() {
  long duration;
  float mm;
  digitalWrite(HC_SR04_Tx, LOW);
  delayMicroseconds(2);
  digitalWrite(HC_SR04_Tx, HIGH);
  delayMicroseconds(10);
  digitalWrite(HC_SR04_Tx, LOW);

  duration = pulseIn(HC_SR04_Rx, HIGH);
  mm = 10*duration / 29 / 2;
  
  // Catch 'bad' values and report as mm = -1;
  if(duration < 600) mm = -1;
  if(mm > 4000) mm = -1;
  
  return mm;
  
}
