// ========================================================
//
// 1421_D_HCSR04
// Need 60 ms delay (datasheet)
// Catch 'bad' values and report as -1
// CBP 15-09-21 
// Status Release
//
// ========================================================

#include <stdio.h>

// Define pins ---------------
#define HC_SR04_Tx 2
#define HC_SR04_Rx 3

float dist;

void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n");
  pinMode(HC_SR04_Tx,OUTPUT);
  pinMode(HC_SR04_Rx,INPUT);
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");

}

void loop() {
  int delayVal;
  // delay of 60 ms required by datasheet
  delayVal = 60;
  dist = getDistance();
  cprintf("dist = %f\n",dist);
  delay(delayVal);
 
}

float getDistance() {
  long duration;
  float mm;
  digitalWrite(HC_SR04_Tx, LOW);
  delayMicroseconds(2);
  digitalWrite(HC_SR04_Tx, HIGH);
  delayMicroseconds(10);
  digitalWrite(HC_SR04_Tx, LOW);

  duration = pulseIn(HC_SR04_Rx, HIGH);
  mm = 10*duration / 29 / 2;
  
  // Catch 'bad' values and report as mm = -1;
  if(duration < 600) mm = -1;
  if(mm > 4000) mm = -1;
  
  //cprintf("Duration (muSec) = %l, dist (mm) = %f\n",duration,mm);
  return mm;
  
}
